// Header file
#ifndef ICD2_DEBUG
 #pragma chip PIC18F8620, core 16, code 32768, ram 0 : 0xEFF

#else
 #pragma chip PIC18F8620, core 16, code 0x7EC0, ram 0 : 0xEFF
 // NOTE: last 320 words are reserved for ICD2 debugging

 char reservedICD2[12] @ 0xEF4;  // reserved RAM for ICD2

 #pragma stackLevels 29   // reserve two levels for debugging

#endif


#pragma accessGPR 0x60

/* Predefined:
TOSU,TOSH,TOSL,
STKPTR,
PCLATU,PCLATH,PCL,
TBLPTRU,TBLPTRH,TBLPTRL,TBLPTR,TABLAT,
PRODH,PRODL,
INTCON,INTCON2,INTCON3,
INDF0,POSTINC0,POSTDEC0,PREINC0,PLUSW0,FSR0H,FSR0L,FSR0,
WREG,
INDF1,POSTINC1,POSTDEC1,PREINC1,PLUSW1,FSR1H,FSR1L,FSR1,
BSR,BSRL,
INDF2,POSTINC2,POSTDEC2,PREINC2,PLUSW2,FSR2H,FSR2L,FSR2,
STATUS,
Carry,DC,Zero_,Overflow,Negative,
*/

char TMR0H   @ 0xFD7;
char TMR0L   @ 0xFD6;
char T0CON   @ 0xFD5;

char OSCCON  @ 0xFD3;
char LVDCON  @ 0xFD2;
char WDTCON  @ 0xFD1;
char RCON    @ 0xFD0;
char TMR1H   @ 0xFCF;
char TMR1L   @ 0xFCE;
char T1CON   @ 0xFCD;
char TMR2    @ 0xFCC;
char PR2     @ 0xFCB;
char T2CON   @ 0xFCA;
char SSPBUF  @ 0xFC9;
char SSPADD  @ 0xFC8;
char SSPSTAT @ 0xFC7;
char SSPCON1 @ 0xFC6;
char SSPCON2 @ 0xFC5;
char ADRESH  @ 0xFC4;
char ADRESL  @ 0xFC3;
char ADCON0  @ 0xFC2;
char ADCON1  @ 0xFC1;
char ADCON2  @ 0xFC0;
char CCPR1H  @ 0xFBF;
char CCPR1L  @ 0xFBE;
char CCP1CON @ 0xFBD;
char CCPR2H  @ 0xFBC;
char CCPR2L  @ 0xFBB;
char CCP2CON @ 0xFBA;
char CCPR3H  @ 0xFB9;
char CCPR3L  @ 0xFB8;
char CCP3CON @ 0xFB7;

char CVRCON  @ 0xFB5;
char CMCON   @ 0xFB4;
char TMR3H   @ 0xFB3;
char TMR3L   @ 0xFB2;
char T3CON   @ 0xFB1;
char PSPCON  @ 0xFB0;
char SPBRG1  @ 0xFAF;
char RCREG1  @ 0xFAE;
char TXREG1  @ 0xFAD;
char TXSTA1  @ 0xFAC;
char RCSTA1  @ 0xFAB;
char EEADRH  @ 0xFAA;
char EEADR   @ 0xFA9;
char EEDATA  @ 0xFA8;
char EECON2  @ 0xFA7;
char EECON1  @ 0xFA6;
char IPR3    @ 0xFA5;
char PIR3    @ 0xFA4;
char PIE3    @ 0xFA3;
char IPR2    @ 0xFA2;
char PIR2    @ 0xFA1;
char PIE2    @ 0xFA0;
char IPR1    @ 0xF9F;
char PIR1    @ 0xF9E;
char PIE1    @ 0xF9D;
char MEMCON  @ 0xF9C;

char TRISJ   @ 0xF9A;
char TRISH   @ 0xF99;
char TRISG   @ 0xF98;
char TRISF   @ 0xF97;
char TRISE   @ 0xF96;
char TRISD   @ 0xF95;
char TRISC   @ 0xF94;
char TRISB   @ 0xF93;
char TRISA   @ 0xF92;
char LATJ    @ 0xF91;
char LATH    @ 0xF90;
char LATG    @ 0xF8F;
char LATF    @ 0xF8E;
char LATE    @ 0xF8D;
char LATD    @ 0xF8C;
char LATC    @ 0xF8B;
char LATB    @ 0xF8A;
char LATA    @ 0xF89;
char PORTJ   @ 0xF88;
char PORTH   @ 0xF87;
char PORTG   @ 0xF86;
char PORTF   @ 0xF85;
char PORTE   @ 0xF84;
char PORTD   @ 0xF83;
char PORTC   @ 0xF82;
char PORTB   @ 0xF81;
char PORTA   @ 0xF80;

char TMR4    @ 0xF78;
char PR4     @ 0xF77;
char T4CON   @ 0xF76;
char CCPR4H  @ 0xF75;
char CCPR4L  @ 0xF74;
char CCP4CON @ 0xF73;
char CCPR5H  @ 0xF72;
char CCPR5L  @ 0xF71;
char CCP5CON @ 0xF70;
char SPBRG2  @ 0xF6F;
char RCREG2  @ 0xF6E;
char TXREG2  @ 0xF6D;
char TXSTA2  @ 0xF6C;
char RCSTA2  @ 0xF6B;

bit RBIF    @ INTCON.0;
bit INT0IF  @ INTCON.1;
bit TMR0IF  @ INTCON.2;
bit RBIE    @ INTCON.3;
bit INT0IE  @ INTCON.4;
bit TMR0IE  @ INTCON.5;
bit PEIE    @ INTCON.6;
bit GIEL    @ INTCON.6;
bit GIE     @ INTCON.7;
bit GIEH    @ INTCON.7;

bit RBIP    @ INTCON2.0;
bit INT3IP  @ INTCON2.1;
bit TMR0IP  @ INTCON2.2;
bit INTEDG3 @ INTCON2.3;
bit INTEDG2 @ INTCON2.4;
bit INTEDG1 @ INTCON2.5;
bit INTEDG0 @ INTCON2.6;
bit RBPU    @ INTCON2.7;

bit INT1IF  @ INTCON3.0;
bit INT2IF  @ INTCON3.1;
bit INT3IF  @ INTCON3.2;
bit INT1IE  @ INTCON3.3;
bit INT2IE  @ INTCON3.4;
bit INT3IE  @ INTCON3.5;
bit INT1IP  @ INTCON3.6;
bit INT2IP  @ INTCON3.7;

bit PSA     @ T0CON.3;
bit T0SE    @ T0CON.4;
bit T0CS    @ T0CON.5;
bit T08BIT  @ T0CON.6;
bit TMR0ON  @ T0CON.7;

bit SCS     @ OSCCON.0;

bit LVDEN   @ LVDCON.4;
bit IRVST   @ LVDCON.5;

bit SWDTEN  @ WDTCON.0;

bit BOR_    @ RCON.0;
bit POR_    @ RCON.1;
bit PD      @ RCON.2;
bit TO      @ RCON.3;
bit RI_     @ RCON.4;
bit IPEN    @ RCON.7;

bit TMR1ON  @ T1CON.0;
bit TMR1CS  @ T1CON.1;
bit T1SYNC_ @ T1CON.2;
bit T1OSCEN @ T1CON.3;
bit T1CKPS0 @ T1CON.4;
bit T1CKPS1 @ T1CON.5;
bit RD16    @ T1CON.7;

bit T2CKPS0 @ T2CON.0;
bit T2CKPS1 @ T2CON.1;
bit TMR2ON  @ T2CON.2;

bit BF      @ SSPSTAT.0;
bit UA      @ SSPSTAT.1;
bit RW_     @ SSPSTAT.2;
bit S       @ SSPSTAT.3;
bit P       @ SSPSTAT.4;
bit DA_     @ SSPSTAT.5;
bit CKE     @ SSPSTAT.6;
bit SMP     @ SSPSTAT.7;

bit CKP     @ SSPCON1.4;
bit SSPEN   @ SSPCON1.5;
bit SSPOV   @ SSPCON1.6;
bit WCOL    @ SSPCON1.7;

bit SEN     @ SSPCON2.0;
bit RSEN    @ SSPCON2.1;
bit PEN     @ SSPCON2.2;
bit RCEN    @ SSPCON2.3;
bit ACKEN   @ SSPCON2.4;
bit ACKDT   @ SSPCON2.5;
bit ACKSTAT @ SSPCON2.6;
bit GCEN    @ SSPCON2.7;

bit ADON    @ ADCON0.0;
bit GO      @ ADCON0.1;
bit CHS0    @ ADCON0.2;
bit CHS1    @ ADCON0.3;
bit CHS2    @ ADCON0.4;
bit CHS3    @ ADCON0.5;

bit VCFG0   @ ADCON1.4;
bit VCFG1   @ ADCON1.5;

bit ADCS0   @ ADCON2.0;
bit ADCS1   @ ADCON2.1;
bit ADCS2   @ ADCON2.2;
bit ADFM    @ ADCON2.7;

bit DC1B0   @ CCP1CON.4;
bit DC1B1   @ CCP1CON.5;

bit DC2B0   @ CCP2CON.4;
bit DC2B1   @ CCP2CON.5;

bit DC3B0   @ CCP3CON.4;
bit DC3B1   @ CCP3CON.5;

bit CVRSS   @ CVRCON.4;
bit CVRR    @ CVRCON.5;
bit CVROE   @ CVRCON.6;
bit CVREN   @ CVRCON.7;

bit CIS     @ CMCON.3;
bit C1INV   @ CMCON.4;
bit C2INV   @ CMCON.5;
bit C1OUT   @ CMCON.6;
bit C2OUT   @ CMCON.7;

bit TMR3ON  @ T3CON.0;
bit TMR3CS  @ T3CON.1;
bit T3SYNC_ @ T3CON.2;
bit T3CCP1  @ T3CON.3;
bit T3CKPS0 @ T3CON.4;
bit T3CKPS1 @ T3CON.5;
bit T3CCP2  @ T3CON.6;
bit T3RD16  @ T3CON.7;

bit PSPMODE @ PSPCON.4;
bit IBOV    @ PSPCON.5;
bit OBF     @ PSPCON.6;
bit IBF     @ PSPCON.7;

bit TX9D1   @ TXSTA1.0;
bit TRMT1   @ TXSTA1.1;
bit BRGH1   @ TXSTA1.2;
bit SYNC1   @ TXSTA1.4;
bit TXEN1   @ TXSTA1.5;
bit TX9_1   @ TXSTA1.6;
bit CSRC1   @ TXSTA1.7;

bit RX9D1   @ RCSTA1.0;
bit OERR1   @ RCSTA1.1;
bit FERR1   @ RCSTA1.2;
bit ADDEN1  @ RCSTA1.3;
bit CREN1   @ RCSTA1.4;
bit SREN1   @ RCSTA1.5;
bit RX9_1   @ RCSTA1.6;
bit SPEN1   @ RCSTA1.7;

bit RD      @ EECON1.0;
bit WR      @ EECON1.1;
bit WREN    @ EECON1.2;
bit WRERR   @ EECON1.3;
bit FREE    @ EECON1.4;
bit CFGS    @ EECON1.6;
bit EEPGD   @ EECON1.7;

bit CCP3IP  @ IPR3.0;
bit CCP4IP  @ IPR3.1;
bit CCP5IP  @ IPR3.2;
bit TMR4IP  @ IPR3.3;
bit TX2IP   @ IPR3.4;
bit RC2IP   @ IPR3.5;

bit CCP3IF  @ PIR3.0;
bit CCP4IF  @ PIR3.1;
bit CCP5IF  @ PIR3.2;
bit TMR4IF  @ PIR3.3;
bit TX2IF   @ PIR3.4;
bit RC2IF   @ PIR3.5;

bit CCP3IE  @ PIE3.0;
bit CCP4IE  @ PIE3.1;
bit CCP5IE  @ PIE3.2;
bit TMR4IE  @ PIE3.3;
bit TX2IE   @ PIE3.4;
bit RC2IE   @ PIE3.5;

bit CCP2IP  @ IPR2.0;
bit TMR3IP  @ IPR2.1;
bit LVDIP   @ IPR2.2;
bit BCLIP   @ IPR2.3;
bit EEIP    @ IPR2.4;
bit CMIP    @ IPR2.6;

bit CCP2IF  @ PIR2.0;
bit TMR3IF  @ PIR2.1;
bit LVDIF   @ PIR2.2;
bit BCLIF   @ PIR2.3;
bit EEIF    @ PIR2.4;
bit CMIF    @ PIR2.6;

bit CCP2IE  @ PIE2.0;
bit TMR3IE  @ PIE2.1;
bit LVDIE   @ PIE2.2;
bit BCLIE   @ PIE2.3;
bit EEIE    @ PIE2.4;
bit CMIE    @ PIE2.6;

bit TMR1IP  @ IPR1.0;
bit TMR2IP  @ IPR1.1;
bit CCP1IP  @ IPR1.2;
bit SSPIP   @ IPR1.3;
bit TXIP    @ IPR1.4;
bit RCIP    @ IPR1.5;
bit ADIP    @ IPR1.6;
bit PSPIP   @ IPR1.7;

bit TMR1IF  @ PIR1.0;
bit TMR2IF  @ PIR1.1;
bit CCP1IF  @ PIR1.2;
bit SSPIF   @ PIR1.3;
bit TXIF    @ PIR1.4;
bit RCIF    @ PIR1.5;
bit ADIF    @ PIR1.6;
bit PSPIF   @ PIR1.7;

bit TMR1IE  @ PIE1.0;
bit TMR2IE  @ PIE1.1;
bit CCP1IE  @ PIE1.2;
bit SSPIE   @ PIE1.3;
bit TXIE    @ PIE1.4;
bit RCIE    @ PIE1.5;
bit ADIE    @ PIE1.6;
bit PSPIE   @ PIE1.7;

bit WM0     @ MEMCON.0;
bit WM1     @ MEMCON.1;
bit WAIT0   @ MEMCON.4;
bit WAIT1   @ MEMCON.5;
bit EBDIS   @ MEMCON.7;

bit T4CKPS0  @ T4CON.0;
bit T4CKPS1  @ T4CON.1;
bit TMR4ON   @ T4CON.2;

bit DC4B0   @ CCP4CON.4;
bit DC4B1   @ CCP4CON.5;

bit DC5B0   @ CCP5CON.4;
bit DC5B1   @ CCP5CON.5;

bit TX9D2   @ TXSTA2.0;
bit TRMT2   @ TXSTA2.1;
bit BRGH2   @ TXSTA2.2;
bit SYNC2   @ TXSTA2.4;
bit TXEN2   @ TXSTA2.5;
bit TX9_2   @ TXSTA2.6;
bit CSRC2   @ TXSTA2.7;

bit RX9D2   @ RCSTA2.0;
bit OERR2   @ RCSTA2.1;
bit FERR2   @ RCSTA2.2;
bit ADDEN2  @ RCSTA2.3;
bit CREN2   @ RCSTA2.4;
bit SREN2   @ RCSTA2.5;
bit RX9_2   @ RCSTA2.6;
bit SPEN2   @ RCSTA2.7;


#if __CC8E__ >= 1500
#pragma config /1 0xF8 LP = OSC // LP oscillator
#pragma config /1 0xF9 XT = OSC // XT oscillator
#pragma config /1 0xFA HS = OSC // HS oscillator
#pragma config /1 0xFB RC = OSC // RC oscillator w/ OSC2 configured as divide-by-4 clock output
#pragma config /1 0xFC EC = OSC // EC oscillator w/ OSC2 configured as divide-by-4 clock output
#pragma config /1 0xFD ECIO = OSC // EC oscillator w/ OSC2 configured as RA6
#pragma config /1 0xFE HSPLL = OSC // HS oscillator with PLL enabled; clock frequency = (4 x FOSC)
#pragma config /1 0xFF RCIO = OSC // RC oscillator w/ OSC2 configured as RA6
#pragma config /1 0xDF OSCS = ON // Timer1 Oscillator system clock switch option is enabled (oscillator switching is enabled)
#pragma config /1 0xFF OSCS = OFF // Oscillator system clock switch option is disabled (main oscillator is source)
#pragma config /2 0xFE PWRT = ON // PWRT enabled
#pragma config /2 0xFF PWRT = OFF // PWRT disabled
#pragma config /2 0xFD BOR = OFF // Brown-out Reset disabled
#pragma config /2 0xFF BOR = ON // Brown-out Reset enabled
#pragma config /2 0xF3 BORV = 45 // VBOR set to 4.5V
#pragma config /2 0xF7 BORV = 42 // VBOR set to 4.2V
#pragma config /2 0xFB BORV = 27 // VBOR set to 2.7V
#pragma config /2 0xFF BORV = 20 // VBOR set to 2.5V
#pragma config /3 0xFE WDT = OFF // WDT disabled (control is placed on the SWDTEN bit)
#pragma config /3 0xFF WDT = ON // WDT enabled
#pragma config /3 0xF1 WDTPS = 1 // 1:1
#pragma config /3 0xF3 WDTPS = 2 // 1:2
#pragma config /3 0xF5 WDTPS = 4 // 1:4
#pragma config /3 0xF7 WDTPS = 8 // 1:8
#pragma config /3 0xF9 WDTPS = 16 // 1:16
#pragma config /3 0xFB WDTPS = 32 // 1:32
#pragma config /3 0xFD WDTPS = 64 // 1:64
#pragma config /3 0xFF WDTPS = 128 // 1:128
#pragma config /4 0xFC XMC = MODE // Extended Microcontroller mode
#pragma config /4 0xFD MPB = MODE // Microprocessor with Boot Block mode
#pragma config /4 0xFE MP = MODE // Microprocessor mode
#pragma config /4 0xFF MC = MODE // Microcontroller mode
#pragma config /4 0x7F WAIT = ON // Wait selections for table reads and table writes are determined by the WAIT1:WAIT0 bits (MEMCOM<5:4>)
#pragma config /4 0xFF WAIT = OFF // Wait selections unavailable for table reads and table writes
#pragma config /5 0xFE CCP2MX = OFF // CCP2 is multiplexed with RB3 in Extended Microcontroller, Microprocessor or Microprocessor with Boot Block mode. Or with RE7 in Microcontroller mode.
#pragma config /5 0xFF CCP2MX = ON // CCP2 input/output is multiplexed with RC1
#pragma config /6 0xFE STVR = OFF // Stack full/underflow will not cause Reset
#pragma config /6 0xFF STVR = ON // Stack full/underflow will cause Reset
#pragma config /6 0xFB LVP = OFF // Low-voltage ICSP disabled
#pragma config /6 0xFF LVP = ON // Low-voltage ICSP enabled
#pragma config /6 0x7F DEBUG = ON // Background debugger enabled. RB6 and RB7 are dedicated to In-Circuit Debug.
#pragma config /6 0xFF DEBUG = OFF // Background debugger disabled. RB6 and RB7 configured as general purpose I/O pins.
#pragma config /8 0xFE CP0 = ON // Block 0 (000200-003FFFh) code-protected
#pragma config /8 0xFF CP0 = OFF // Block 0 (000200-003FFFh) not code-protected
#pragma config /8 0xFD CP1 = ON // Block 1 (004000-007FFFh) code-protected
#pragma config /8 0xFF CP1 = OFF // Block 1 (004000-007FFFh) not code-protected
#pragma config /8 0xFB CP2 = ON // Block 2 (008000-00BFFFh) code-protected
#pragma config /8 0xFF CP2 = OFF // Block 2 (008000-00BFFFh) not code-protected
#pragma config /8 0xF7 CP3 = ON // Block 3 (00C000-00FFFFh) code-protected
#pragma config /8 0xFF CP3 = OFF // Block 3 (00C000-00FFFFh) not code-protected
#pragma config /9 0xBF CPB = ON // Boot Block (000000-0001FFh) code-protected
#pragma config /9 0xFF CPB = OFF // Boot Block (000000-0001FFh) not code-protected
#pragma config /9 0x7F CPD = ON // Data EEPROM code-protected
#pragma config /9 0xFF CPD = OFF // Data EEPROM not code-protected
#pragma config /10 0xFE WRT0 = ON // Block 0 (000200-003FFFh) write-protected
#pragma config /10 0xFF WRT0 = OFF // Block 0 (000200-003FFFh) not write-protected
#pragma config /10 0xFD WRT1 = ON // Block 1 (004000-007FFFh) write-protected
#pragma config /10 0xFF WRT1 = OFF // Block 1 (004000-007FFFh) not write-protected
#pragma config /10 0xFB WRT2 = ON // Block 2 (008000-00BFFFh) write-protected
#pragma config /10 0xFF WRT2 = OFF // Block 2 (008000-00BFFFh) not write-protected
#pragma config /10 0xF7 WRT3 = ON // Block 3 (00C000-00FFFFh) write-protected
#pragma config /10 0xFF WRT3 = OFF // Block 3 (00C000-00FFFFh) not write-protected
#pragma config /11 0xDF WRTC = ON // Configuration registers (300000-3000FFh) write-protected
#pragma config /11 0xFF WRTC = OFF // Configuration registers (300000-3000FFh) not write-protected
#pragma config /11 0xBF WRTB = ON // Boot Block (000000-0001FFh) write-protected
#pragma config /11 0xFF WRTB = OFF // Boot Block (000000-0001FFh) not write-protected
#pragma config /11 0x7F WRTD = ON // Data EEPROM write-protected
#pragma config /11 0xFF WRTD = OFF // Data EEPROM not write-protected
#pragma config /12 0xFE EBTR0 = ON // Block 0 (000200-003FFFh) protected from table reads executed in other blocks
#pragma config /12 0xFF EBTR0 = OFF // Block 0 (000200-003FFFh) not protected from table reads executed in other blocks
#pragma config /12 0xFD EBTR1 = ON // Block 1 (004000-007FFFh) protected from table reads executed in other blocks
#pragma config /12 0xFF EBTR1 = OFF // Block 1 (004000-007FFFh) not protected from table reads executed in other blocks
#pragma config /12 0xFB EBTR2 = ON // Block 2 (008000-00BFFFh) protected from table reads executed in other blocks
#pragma config /12 0xFF EBTR2 = OFF // Block 2 (008000-00BFFFh) not protected from table reads executed in other blocks
#pragma config /12 0xF7 EBTR3 = ON // Block 3 (00C000-00FFFFh) protected from table reads executed in other blocks
#pragma config /12 0xFF EBTR3 = OFF // Block 3 (00C000-00FFFFh) not protected from table reads executed in other blocks
#pragma config /13 0xBF EBTRB = ON // Boot Block (000000-0001FFh) protected from table reads executed in other blocks
#pragma config /13 0xFF EBTRB = OFF // Boot Block (000000-0001FFh) not protected from table reads executed in other blocks
#endif
