// Header file
#pragma chip PIC18F67K40, core 16, code 65536, ram 0 : 0xDDD

// Extended Instruction Set

#pragma accessGPR 0x60

/* Predefined:
TOSU,TOSH,TOSL,
STKPTR,
PCLATU,PCLATH,PCL,
TBLPTRU,TBLPTRH,TBLPTRL,TBLPTR,TABLAT,
PRODH,PRODL,
INTCON,INTCON2,INTCON3,
INDF0,POSTINC0,POSTDEC0,PREINC0,PLUSW0,FSR0H,FSR0L,FSR0,
WREG,
INDF1,POSTINC1,POSTDEC1,PREINC1,PLUSW1,FSR1H,FSR1L,FSR1,
BSR,BSRL,
INDF2,POSTINC2,POSTDEC2,PREINC2,PLUSW2,FSR2H,FSR2L,FSR2,
STATUS,
Carry,DC,Zero_,Overflow,Negative,
*/

char PCON0    @ 0xFD7;
char T0CON1   @ 0xFD6;
char T0CON0   @ 0xFD5;
char TMR0H    @ 0xFD4;
char TMR0L    @ 0xFD3;
char T1CLK    @ 0xFD2;
char T1GATE   @ 0xFD1;
char T1GCON   @ 0xFD0;
char T1CON    @ 0xFCF;
char TMR1H    @ 0xFCE;
char TMR1L    @ 0xFCD;
char T3CLK    @ 0xFCC;
char T3GATE   @ 0xFCB;
char T3GCON   @ 0xFCA;
char T3CON    @ 0xFC9;
char TMR3H    @ 0xFC8;
char TMR3L    @ 0xFC7;
char T5CLK    @ 0xFC6;
char T5GATE   @ 0xFC5;
char T5GCON   @ 0xFC4;
char T5CON    @ 0xFC3;
char TMR5H    @ 0xFC2;
char TMR5L    @ 0xFC1;
char T2RST    @ 0xFC0;
char T2CLKCON @ 0xFBF;
char T2HLT    @ 0xFBE;
char T2CON    @ 0xFBD;
char T2PR     @ 0xFBC;
char T2TMR    @ 0xFBB;
char T4RST    @ 0xFBA;
char T4CLKCON @ 0xFB9;
char T4HLT    @ 0xFB8;
char T4CON    @ 0xFB7;
char T4PR     @ 0xFB6;
char T4TMR    @ 0xFB5;
char T6RST    @ 0xFB4;
char T6CLKCON @ 0xFB3;
char T6HLT    @ 0xFB2;
char T6CON    @ 0xFB1;
char T6PR     @ 0xFB0;
char T6TMR    @ 0xFAF;
char CCPTMRS1 @ 0xFAE;
char CCPTMRS0 @ 0xFAD;
char CCP1CAP  @ 0xFAC;
char CCP1CON  @ 0xFAB;
char CCPR1H   @ 0xFAA;
char CCPR1L   @ 0xFA9;
char CCP2CAP  @ 0xFA8;
char CCP2CON  @ 0xFA7;
char CCPR2H   @ 0xFA6;
char CCPR2L   @ 0xFA5;
char PWM6CON  @ 0xFA4;
char PWM6DCH  @ 0xFA3;
char PWM6DCL  @ 0xFA2;
char PWM7CON  @ 0xFA1;
char PWM7DCH  @ 0xFA0;
char PWM7DCL  @ 0xF9F;
char BAUD1CON @ 0xF9E;
char TX1STA   @ 0xF9D;
char RC1STA   @ 0xF9C;
char SP1BRGH  @ 0xF9B;
char SP1BRGL  @ 0xF9A;
char TX1REG   @ 0xF99;
char RC1REG   @ 0xF98;
char SSP1CON3 @ 0xF97;
char SSP1CON2 @ 0xF96;
char SSP1CON1 @ 0xF95;
char SSP1STAT @ 0xF94;
char SSP1MSK  @ 0xF93;
char SSP1ADD  @ 0xF92;
char SSP1BUF  @ 0xF91;
char PORTH    @ 0xF90;
char PORTG    @ 0xF8F;
char PORTF    @ 0xF8E;
char PORTE    @ 0xF8D;
char PORTD    @ 0xF8C;
char PORTC    @ 0xF8B;
char PORTB    @ 0xF8A;
char PORTA    @ 0xF89;
char TRISH    @ 0xF88;
char TRISG    @ 0xF87;
char TRISF    @ 0xF86;
char TRISE    @ 0xF85;
char TRISD    @ 0xF84;
char TRISC    @ 0xF83;
char TRISB    @ 0xF82;
char TRISA    @ 0xF81;
char LATH     @ 0xF80;
char LATG     @ 0xF7F;
char LATF     @ 0xF7E;
char LATE     @ 0xF7D;
char LATD     @ 0xF7C;
char LATC     @ 0xF7B;
char LATB     @ 0xF7A;
char LATA     @ 0xF79;
char NVMCON2  @ 0xF78;
char NVMCON1  @ 0xF77;
char NVMDAT   @ 0xF76;
char NVMADRH  @ 0xF75;
char NVMADRL  @ 0xF74;
char ADFLTRH  @ 0xF73;
char ADFLTRL  @ 0xF72;
char ADACCH   @ 0xF71;
char ADACCL   @ 0xF70;
char ADERRH   @ 0xF6F;
char ADERRL   @ 0xF6E;
char ADUTHH   @ 0xF6D;
char ADUTHL   @ 0xF6C;
char ADLTHH   @ 0xF6B;
char ADLTHL   @ 0xF6A;
char ADSTPTH  @ 0xF69;
char ADSTPTL  @ 0xF68;
char ADCNT    @ 0xF67;
char ADRPT    @ 0xF66;
char ADSTAT   @ 0xF65;
char ADRESH   @ 0xF64;
char ADRESL   @ 0xF63;
char ADPREVH  @ 0xF62;
char ADPREVL  @ 0xF61;
char ADCON0   @ 0xF60;
char ADPCH    @ 0xF5F;
char ADPRE    @ 0xF5E;
char ADCAP    @ 0xF5D;
char ADACQ    @ 0xF5C;
char ADCON3   @ 0xF5B;
char ADCON2   @ 0xF5A;
char ADCON1   @ 0xF59;
char ADREF    @ 0xF58;
char ADCLK    @ 0xF57;
char ADACT    @ 0xF56;
char MDCARH   @ 0xF55;
char MDCARL   @ 0xF54;
char MDSRC    @ 0xF53;
char MDCON1   @ 0xF52;
char MDCON0   @ 0xF51;
char SCANTRIG @ 0xF50;
char SCANCON0 @ 0xF4F;
char SCANHADRU @ 0xF4E;
char SCANHADRH @ 0xF4D;
char SCANHADRL @ 0xF4C;
char SCANLADRU @ 0xF4B;
char SCANLADRH @ 0xF4A;
char SCANLADRL @ 0xF49;
char CRCCON1  @ 0xF48;
char CRCCON0  @ 0xF47;
char CRCXORH  @ 0xF46;
char CRCXORL   @ 0xF45;
char CRCSHIFTH @ 0xF44;
char CRCSHIFTL @ 0xF43;
char CRCACCH  @ 0xF42;
char CRCACCL  @ 0xF41;
char CRCDATH  @ 0xF40;
char CRCDATL  @ 0xF3F;
char CWG1STR  @ 0xF3E;
char CWG1AS1  @ 0xF3D;
char CWG1AS0  @ 0xF3C;
char CWG1CON1 @ 0xF3B;
char CWG1CON0 @ 0xF3A;
char CWG1DBF  @ 0xF39;
char CWG1DBR  @ 0xF38;
char CWG1ISM  @ 0xF37;
char CWG1CLKCON @ 0xF36;
char CLKRCLK  @ 0xF35;
char CLKRCON  @ 0xF34;
char T7CLK    @ 0xF33;
char T7GATE   @ 0xF32;
char T7GCON   @ 0xF31;
char T7CON    @ 0xF30;
char TMR7H    @ 0xF2F;
char TMR7L    @ 0xF2E;
char T8RST    @ 0xF2D;
char T8CLKCON @ 0xF2C;
char T8HLT    @ 0xF2B;
char T8CON    @ 0xF2A;
char T8PR     @ 0xF29;
char T8TMR    @ 0xF28;
char CCP3CAP  @ 0xF27;
char CCP3CON  @ 0xF26;
char CCPR3H   @ 0xF25;
char CCPR3L   @ 0xF24;
char CCP4CAP  @ 0xF23;
char CCP4CON  @ 0xF22;
char CCPR4H   @ 0xF21;
char CCPR4L   @ 0xF20;
char CCP5CAP  @ 0xF1F;
char CCP5CON  @ 0xF1E;
char CCPR5H   @ 0xF1D;
char CCPR5L   @ 0xF1C;
char SMT1WIN  @ 0xF1B;
char SMT1SIG  @ 0xF1A;
char SMT1CLK  @ 0xF19;
char SMT1STAT @ 0xF18;
char SMT1CON1 @ 0xF17;
char SMT1CON0 @ 0xF16;
char SMT1PRU  @ 0xF15;
char SMT1PRH  @ 0xF14;
char SMT1PRL  @ 0xF13;
char SMT1CPWU @ 0xF12;
char SMT1CPWH @ 0xF11;
char SMT1CPWL @ 0xF10;
char SMT1CPRU @ 0xF0F;
char SMT1CPRH @ 0xF0E;
char SMT1CPRL @ 0xF0D;
char SMT1TMRU @ 0xF0C;
char SMT1TMRH @ 0xF0B;
char SMT1TMRL @ 0xF0A;
char SMT2WIN  @ 0xF09;
char SMT2SIG  @ 0xF08;
char SMT2CLK  @ 0xF07;
char SMT2STAT @ 0xF06;
char SMT2CON1 @ 0xF05;
char SMT2CON0 @ 0xF04;
char SMT2PRU  @ 0xF03;
char SMT2PRH  @ 0xF02;
char SMT2PRL  @ 0xF01;
char SMT2CPWU @ 0xF00;
char SMT2CPWH @ 0xEFF;
char SMT2CPWL @ 0xEFE;
char SMT2CPRU @ 0xEFD;
char SMT2CPRH @ 0xEFC;
char SMT2CPRL @ 0xEFB;
char SMT2TMRU @ 0xEFA;
char SMT2TMRH @ 0xEF9;
char SMT2TMRL @ 0xEF8;
char BAUD2CON @ 0xEF7;
char TX2STA   @ 0xEF6;
char RC2STA   @ 0xEF5;
char SP2BRGH  @ 0xEF4;
char SP2BRGL  @ 0xEF3;
char TX2REG   @ 0xEF2;
char RC2REG   @ 0xEF1;
char BAUD3CON @ 0xEF0;
char TX3STA   @ 0xEEF;
char RC3STA   @ 0xEEE;
char SP3BRGH  @ 0xEED;
char SP3BRGL  @ 0xEEC;
char TX3REG   @ 0xEEB;
char RC3REG   @ 0xEEA;
char BAUD4CON @ 0xEE9;
char TX4STA   @ 0xEE8;
char RC4STA   @ 0xEE7;
char SP4BRGH  @ 0xEE6;
char SP4BRGL  @ 0xEE5;
char TX4REG   @ 0xEE4;
char RC4REG   @ 0xEE3;
char BAUD5CON @ 0xEE2;
char TX5STA   @ 0xEE1;
char RC5STA   @ 0xEE0;
char SP5BRGH  @ 0xEDF;
char SP5BRGL  @ 0xEDE;
char TX5REG   @ 0xEDD;
char RC5REG   @ 0xEDC;
char SSP2CON3 @ 0xEDB;
char SSP2CON2 @ 0xEDA;
char SSP2CON1 @ 0xED9;
char SSP2STAT @ 0xED8;
char SSP2MSK  @ 0xED7;
char SSP2ADD  @ 0xED6;
char SSP2BUF  @ 0xED5;
char CMOUT    @ 0xED4;
char CM1PCH   @ 0xED3;
char CM1NCH   @ 0xED2;
char CM1CON1  @ 0xED1;
char CM1CON0  @ 0xED0;
char CM2PCH   @ 0xECF;
char CM2NCH   @ 0xECE;
char CM2CON1  @ 0xECD;
char CM2CON0  @ 0xECC;
char CM3PCH   @ 0xECB;
char CM3NCH   @ 0xECA;
char CM3CON1  @ 0xEC9;
char CM3CON0  @ 0xEC8;
char DAC1CON1 @ 0xEC7;
char DAC1CON0 @ 0xEC6;
char ZCDCON   @ 0xEC5;
char FVRCON   @ 0xEC4;
char HLVDCON1 @ 0xEC3;
char HLVDCON0 @ 0xEC2;
char ANSELH   @ 0xEC1;
char WPUH     @ 0xEC0;
char ODCONH   @ 0xEBF;
char SLRCONH  @ 0xEBE;
char INLVLH   @ 0xEBD;
char ANSELG   @ 0xEBC;
char WPUG     @ 0xEBB;
char ODCONG   @ 0xEBA;
char SLRCONG  @ 0xEB9;
char INLVLG   @ 0xEB8;
char IOCGP    @ 0xEB7;
char IOCGN    @ 0xEB6;
char IOCGF    @ 0xEB5;
char ANSELF   @ 0xEB4;
char WPUF     @ 0xEB3;
char ODCONF   @ 0xEB2;
char SLRCONF  @ 0xEB1;
char INLVLF   @ 0xEB0;
char ANSELE   @ 0xEAF;
char WPUE     @ 0xEAE;
char ODCONE   @ 0xEAD;
char SLRCONE  @ 0xEAC;
char INLVLE   @ 0xEAB;
char IOCEP    @ 0xEAA;
char IOCEN    @ 0xEA9;
char IOCEF    @ 0xEA8;
char ANSELD   @ 0xEA7;
char WPUD     @ 0xEA6;
char ODCOND   @ 0xEA5;
char SLRCOND  @ 0xEA4;
char INLVLD   @ 0xEA3;
char ANSELC   @ 0xEA2;
char WPUC     @ 0xEA1;
char ODCONC   @ 0xEA0;
char SLRCONC  @ 0xE9F;
char INLVLC   @ 0xE9E;
char IOCCP    @ 0xE9D;
char IOCCN    @ 0xE9C;
char IOCCF    @ 0xE9B;
char ANSELB   @ 0xE9A;
char WPUB     @ 0xE99;
char ODCONB   @ 0xE98;
char SLRCONB  @ 0xE97;
char INLVLB   @ 0xE96;
char IOCBP    @ 0xE95;
char IOCBN    @ 0xE94;
char IOCBF    @ 0xE93;
char ANSELA   @ 0xE92;
char WPUA     @ 0xE91;
char ODCONA   @ 0xE90;
char SLRCONA  @ 0xE8F;
char INLVLA   @ 0xE8E;
char RH3PPS   @ 0xE8D;
char RH2PPS   @ 0xE8C;
char RH1PPS   @ 0xE8B;
char RH0PPS   @ 0xE8A;
char RG7PPS   @ 0xE89;
char RG6PPS   @ 0xE88;

char RG4PPS   @ 0xE86;
char RG3PPS   @ 0xE85;
char RG2PPS   @ 0xE84;
char RG1PPS   @ 0xE83;
char RG0PPS   @ 0xE82;
char RF7PPS   @ 0xE81;
char RF6PPS   @ 0xE80;
char RF5PPS   @ 0xE7F;
char RF4PPS   @ 0xE7E;
char RF3PPS   @ 0xE7D;
char RF2PPS   @ 0xE7C;
char RF1PPS   @ 0xE7B;
char RF0PPS   @ 0xE7A;
char RE7PPS   @ 0xE79;
char RE6PPS   @ 0xE78;
char RE5PPS   @ 0xE77;
char RE4PPS   @ 0xE76;
char RE3PPS   @ 0xE75;
char RE2PPS   @ 0xE74;
char RE1PPS   @ 0xE73;
char RE0PPS   @ 0xE72;
char RD7PPS   @ 0xE71;
char RD6PPS   @ 0xE70;
char RD5PPS   @ 0xE6F;
char RD4PPS   @ 0xE6E;
char RD3PPS   @ 0xE6D;
char RD2PPS   @ 0xE6C;
char RD1PPS   @ 0xE6B;
char RD0PPS   @ 0xE6A;
char RC7PPS   @ 0xE69;
char RC6PPS   @ 0xE68;
char RC5PPS   @ 0xE67;
char RC4PPS   @ 0xE66;
char RC3PPS   @ 0xE65;
char RC2PPS   @ 0xE64;
char RC1PPS   @ 0xE63;
char RC0PPS   @ 0xE62;
char RB7PPS   @ 0xE61;
char RB6PPS   @ 0xE60;
char RB5PPS   @ 0xE5F;
char RB4PPS   @ 0xE5E;
char RB3PPS   @ 0xE5D;
char RB2PPS   @ 0xE5C;
char RB1PPS   @ 0xE5B;
char RB0PPS   @ 0xE5A;
char RA7PPS   @ 0xE59;
char RA6PPS   @ 0xE58;
char RA5PPS   @ 0xE57;
char RA4PPS   @ 0xE56;
char RA3PPS   @ 0xE55;
char RA2PPS   @ 0xE54;
char RA1PPS   @ 0xE53;
char RA0PPS   @ 0xE52;
char PMD5     @ 0xE51;
char PMD4     @ 0xE50;
char PMD3     @ 0xE4F;
char PMD2     @ 0xE4E;
char PMD1     @ 0xE4D;
char PMD0     @ 0xE4C;
char BORCON   @ 0xE4B;
#ifdef _18F67K40
char VREGCON  @ 0xE4A;
#endif
char OSCFRQ   @ 0xE49;
char OSCTUNE  @ 0xE48;
char OSCEN    @ 0xE47;
char OSCSTAT  @ 0xE46;
char OSCCON3  @ 0xE45;
char OSCCON2  @ 0xE44;
char OSCCON1  @ 0xE43;
char CPUDOZE  @ 0xE42;
char WDTTMR   @ 0xE41;
char WDTPSH   @ 0xE40;
char WDTPSL   @ 0xE3F;
char WDTCON1  @ 0xE3E;
char WDTCON0  @ 0xE3D;
char PIR9     @ 0xE3C;
char PIR8     @ 0xE3B;
char PIR7     @ 0xE3A;
char PIR6     @ 0xE39;
char PIR5     @ 0xE38;
char PIR4     @ 0xE37;
char PIR3     @ 0xE36;
char PIR2     @ 0xE35;
char PIR1     @ 0xE34;
char PIR0     @ 0xE33;
char PIE9     @ 0xE32;
char PIE8     @ 0xE31;
char PIE7     @ 0xE30;
char PIE6     @ 0xE2F;
char PIE5     @ 0xE2E;
char PIE4     @ 0xE2D;
char PIE3     @ 0xE2C;
char PIE2     @ 0xE2B;
char PIE1     @ 0xE2A;
char PIE0     @ 0xE29;
char IPR9     @ 0xE28;
char IPR8     @ 0xE27;
char IPR7     @ 0xE26;
char IPR6     @ 0xE25;
char IPR5     @ 0xE24;
char IPR4     @ 0xE23;
char IPR3     @ 0xE22;
char IPR2     @ 0xE21;
char IPR1     @ 0xE20;
char IPR0     @ 0xE1F;
char SSP2SSPPS @ 0xE1E;
char SSP2DATPPS @ 0xE1D;
char SSP2CLKPPS @ 0xE1C;
char SSP1SSPPS @ 0xE1B;
char SSP1DATPPS @ 0xE1A;
char SSP1CLKPPS @ 0xE19;
char TX5PPS   @ 0xE18;
char RX5PPS   @ 0xE17;
char TX4PPS   @ 0xE16;
char RX4PPS   @ 0xE15;
char TX3PPS   @ 0xE14;
char RX3PPS   @ 0xE13;
char TX2PPS   @ 0xE12;
char RX2PPS   @ 0xE11;
char TX1PPS   @ 0xE10;
char RX1PPS   @ 0xE0F;
char MDSRCPPS @ 0xE0E;
char MDCARHPPS @ 0xE0D;
char MDCARLPPS @ 0xE0C;
char CWGINPPS @ 0xE0B;
char SMT2SIGPPS @ 0xE0A;
char SMT2WINPPS @ 0xE09;
char SMT1SIGPPS @ 0xE08;
char SMT1WINPPS @ 0xE07;
char CCP5PPS  @ 0xE06;
char CCP4PPS  @ 0xE05;
char CCP3PPS  @ 0xE04;
char CCP2PPS  @ 0xE03;
char CCP1PPS  @ 0xE02;
char ADACTPPS @ 0xE01;
char T8INPPS  @ 0xE00;
char T6INPPS  @ 0xDFF;
char T4INPPS  @ 0xDFE;
char T2INPPS  @ 0xDFD;
char T7GPPS   @ 0xDFC;
char T7CKIPPS @ 0xDFB;
char T5GPPS   @ 0xDFA;
char T5CKIPPS @ 0xDF9;
char T3GPPS   @ 0xDF8;
char T3CKIPPS @ 0xDF7;
char T1GPPS   @ 0xDF6;
char T1CKIPPS @ 0xDF5;
char T0CKIPPS @ 0xDF4;
char INT3PPS  @ 0xDF3;
char INT2PPS  @ 0xDF2;
char INT1PPS  @ 0xDF1;
char INT0PPS  @ 0xDF0;
char PPSLOCK  @ 0xDEF;

bit INT0EDG @ INTCON.0;
bit INT1EDG @ INTCON.1;
bit INT2EDG @ INTCON.2;
bit INT3EDG @ INTCON.3;
bit IPEN    @ INTCON.5;
bit PEIE    @ INTCON.6;
bit GIEL    @ INTCON.6;
bit GIE     @ INTCON.7;
bit GIEH    @ INTCON.7;

bit PD      @ STATUS.5;
bit TO      @ STATUS.6;

bit BOR_    @ PCON0.0;
bit POR_    @ PCON0.1;
bit RI_     @ PCON0.2;
bit RMCLR_  @ PCON0.3;
bit RWDT_   @ PCON0.4;
bit WDTWV_  @ PCON0.5;
bit STKUNF  @ PCON0.6;
bit STKOVF  @ PCON0.7;

bit T016BIT @ T0CON0.4;
bit T0OUT   @ T0CON0.5;
bit T0EN    @ T0CON0.7;

bit TMR1ON  @ T1CON.0;
bit T1RD16  @ T1CON.1;
bit T1SYNC_ @ T1CON.2;

bit RD      @ NVMCON1.0;
bit WR      @ NVMCON1.1;
bit WREN    @ NVMCON1.2;
bit WRERR   @ NVMCON1.3;
bit FREE    @ NVMCON1.4;
bit NVMREG0 @ NVMCON1.6;
bit NVMREG1 @ NVMCON1.7;

bit ADGO    @ ADCON0.0;
bit ADFM    @ ADCON0.2;
bit ADCS    @ ADCON0.4;
bit ADCONT  @ ADCON0.6;
bit ADON    @ ADCON0.7;

bit ADDSEN  @ ADCON1.0;
bit ADGPOL  @ ADCON1.5;
bit ADIPEN  @ ADCON1.6;
bit ADPPOL  @ ADCON1.7;

bit STRA    @ CWG1STR.0;
bit STRB    @ CWG1STR.1;
bit STRC    @ CWG1STR.2;
bit STRD    @ CWG1STR.3;
bit OVRA    @ CWG1STR.4;
bit OVRB    @ CWG1STR.5;
bit OVRC    @ CWG1STR.6;
bit OVRD    @ CWG1STR.7;

bit ZCDINTN @ ZCDCON.0;
bit ZCDINTP @ ZCDCON.1;
bit ZCDPOL  @ ZCDCON.4;
bit ZCDOUT  @ ZCDCON.5;
bit ZCDSEN  @ ZCDCON.7;

bit ADFVR0  @ FVRCON.0;
bit ADFVR1  @ FVRCON.1;
bit CDAFVR0 @ FVRCON.2;
bit CDAFVR1 @ FVRCON.3;
bit TSRNG   @ FVRCON.4;
bit TSEN    @ FVRCON.5;
bit FVRRDY  @ FVRCON.6;
bit FVREN   @ FVRCON.7;

bit MSSP1MD @ PMD5.0;
bit MSSP2MD @ PMD5.1;
bit UART1MD @ PMD5.2;
bit UART2MD @ PMD5.3;
bit UART3MD @ PMD5.4;
bit UART4MD @ PMD5.5;
bit UART5MD @ PMD5.6;

bit CCP1MD  @ PMD4.0;
bit CCP2MD  @ PMD4.1;
bit CCP3MD  @ PMD4.2;
bit CCP4MD  @ PMD4.3;
bit CCP5MD  @ PMD4.4;
bit PWM6MD  @ PMD4.5;
bit PWM7MD  @ PMD4.6;

bit ZCDMD   @ PMD3.0;
bit CMP1MD  @ PMD3.1;
bit CMP2MD  @ PMD3.2;
bit CMP3MD  @ PMD3.3;
bit ADCMD   @ PMD3.5;
bit DACMD   @ PMD3.6;

bit TMR8MD  @ PMD2.0;
bit SMT1MD  @ PMD2.1;
bit SMT2MD  @ PMD2.2;
bit DSMMD   @ PMD2.3;
bit CWGMD   @ PMD2.5;

bit TMR0MD  @ PMD1.0;
bit TMR1MD  @ PMD1.1;
bit TMR2MD  @ PMD1.2;
bit TMR3MD  @ PMD1.3;
bit TMR4MD  @ PMD1.4;
bit TMR5MD  @ PMD1.5;
bit TMR6MD  @ PMD1.6;
bit TMR7MD  @ PMD1.7;

bit IOCMD   @ PMD0.0;
bit CLKRMD  @ PMD0.1;
bit NVMMD   @ PMD0.2;
bit SCANMD  @ PMD0.3;
bit CRCMD   @ PMD0.4;
bit HLVDMD  @ PMD0.5;
bit FVRMD   @ PMD0.6;
bit SYSCMD  @ PMD0.7;

bit BORRDY  @ BORCON.0;
bit SBOREN  @ BORCON.7;

#ifdef _18F67K40
bit VREGPM  @ VREGCON.1;
#endif

bit ADOEN   @ OSCEN.2;
bit SOSCEN  @ OSCEN.3;
bit LFOEN   @ OSCEN.4;
bit MFOEN   @ OSCEN.5;
bit HFOEN   @ OSCEN.6;
bit EXTOEN  @ OSCEN.7;

bit PLLR    @ OSCSTAT.0;
bit ADOR    @ OSCSTAT.2;
bit SOR     @ OSCSTAT.3;
bit LFOR    @ OSCSTAT.4;
bit MFOR    @ OSCSTAT.5;
bit HFOR    @ OSCSTAT.6;
bit EXTOR   @ OSCSTAT.7;

bit DOZE0   @ CPUDOZE.0;
bit DOZE1   @ CPUDOZE.1;
bit DOZE2   @ CPUDOZE.2;
bit DOE     @ CPUDOZE.4;
bit ROI     @ CPUDOZE.5;
bit DOZEN   @ CPUDOZE.6;
bit IDLEN   @ CPUDOZE.7;

bit SMT1IF  @ PIR9.0;
bit SMT1PRAIF @ PIR9.1;
bit SMT1PWAIF @ PIR9.2;
bit SMT2IF  @ PIR9.3;
bit SMT2PRAIF @ PIR9.4;
bit SMT2PWAIF @ PIR9.5;

bit CWG1IF  @ PIR8.0;
bit NVMIF   @ PIR8.5;
bit CRCIF   @ PIR8.6;
bit DMAIF   @ PIR8.7;

bit CCP1IF  @ PIR7.0;
bit CCP2IF  @ PIR7.1;
bit CCP3IF  @ PIR7.2;
bit CCP4IF  @ PIR7.3;
bit CCP5IF  @ PIR7.4;

bit TMR1GIF @ PIR6.0;
bit TMR3GIF @ PIR6.1;
bit TMR5GIF @ PIR6.2;
bit TMR7GIF @ PIR6.3;

bit TMR1IF  @ PIR5.0;
bit TMR2IF  @ PIR5.1;
bit TMR3IF  @ PIR5.2;
bit TMR4IF  @ PIR5.3;
bit TMR5IF  @ PIR5.4;
bit TMR6IF  @ PIR5.5;
bit TMR7IF  @ PIR5.6;
bit TMR8IF  @ PIR5.7;

bit TX3IF   @ PIR4.0;
bit RC3IF   @ PIR4.1;
bit TX4IF   @ PIR4.2;
bit RC4IF   @ PIR4.3;
bit TX5IF   @ PIR4.4;
bit RC5IF   @ PIR4.5;

bit SSP1IF  @ PIR3.0;
bit BCL1IF  @ PIR3.1;
bit SSP2IF  @ PIR3.2;
bit BCL2IF  @ PIR3.3;
bit TX1IF   @ PIR3.4;
bit RC1IF   @ PIR3.5;
bit TX2IF   @ PIR3.6;
bit RC2IF   @ PIR3.7;

bit C1IF    @ PIR2.0;
bit C2IF    @ PIR2.1;
bit C3IF    @ PIR2.2;
bit ZCDIF   @ PIR2.6;
bit HLVDIF  @ PIR2.7;

bit ADIF    @ PIR1.0;
bit ADTIF   @ PIR1.1;
bit CSWIF   @ PIR1.6;
bit OSCFIF  @ PIR1.7;

bit INT0IF  @ PIR0.0;
bit INT1IF  @ PIR0.1;
bit INT2IF  @ PIR0.2;
bit INT3IF  @ PIR0.3;
bit IOCIF   @ PIR0.4;
bit TMR0IF  @ PIR0.5;

bit SMT1IE  @ PIE9.0;
bit SMT1PRAIE @ PIE9.1;
bit SMT1PWAIE @ PIE9.2;
bit SMT2IE  @ PIE9.3;
bit SMT2PRAIE @ PIE9.4;
bit SMT2PWAIE @ PIE9.5;

bit CWG1IE  @ PIE8.0;
bit NVMIE   @ PIE8.5;
bit CRCIE   @ PIE8.6;
bit DMAIE   @ PIE8.7;

bit CCP1IE  @ PIE7.0;
bit CCP2IE  @ PIE7.1;
bit CCP3IE  @ PIE7.2;
bit CCP4IE  @ PIE7.3;
bit CCP5IE  @ PIE7.4;

bit TMR1GIE @ PIE6.0;
bit TMR3GIE @ PIE6.1;
bit TMR5GIE @ PIE6.2;
bit TMR7GIE @ PIE6.3;

bit TMR1IE  @ PIE5.0;
bit TMR2IE  @ PIE5.1;
bit TMR3IE  @ PIE5.2;
bit TMR4IE  @ PIE5.3;
bit TMR5IE  @ PIE5.4;
bit TMR6IE  @ PIE5.5;
bit TMR7IE  @ PIE5.6;
bit TMR8IE  @ PIE5.7;

bit TX3IE   @ PIE4.0;
bit RC3IE   @ PIE4.1;
bit TX4IE   @ PIE4.2;
bit RC4IE   @ PIE4.3;
bit TX5IE   @ PIE4.4;
bit RC5IE   @ PIE4.5;

bit SSP1IE  @ PIE3.0;
bit BCL1IE  @ PIE3.1;
bit SSP2IE  @ PIE3.2;
bit BCL2IE  @ PIE3.3;
bit TX1IE   @ PIE3.4;
bit RC1IE   @ PIE3.5;
bit TX2IE   @ PIE3.6;
bit RC2IE   @ PIE3.7;

bit C1IE    @ PIE2.0;
bit C2IE    @ PIE2.1;
bit C3IE    @ PIE2.2;
bit ZCDIE   @ PIE2.6;
bit HLVDIE  @ PIE2.7;

bit ADIE    @ PIE1.0;
bit ADTIE   @ PIE1.1;
bit CSWIE   @ PIE1.6;
bit OSCFIE  @ PIE1.7;

bit INT0IE  @ PIE0.0;
bit INT1IE  @ PIE0.1;
bit INT2IE  @ PIE0.2;
bit INT3IE  @ PIE0.3;
bit IOCIE   @ PIE0.4;
bit TMR0IE  @ PIE0.5;

bit SMT1IP  @ IPR9.0;
bit SMT1PRAIP @ IPR9.1;
bit SMT1PWAIP @ IPR9.2;
bit SMT2IP  @ IPR9.3;
bit SMT2PRAIP @ IPR9.4;
bit SMT2PWAIP @ IPR9.5;

bit CWG1IP  @ IPR8.0;
bit NVMIP   @ IPR8.5;
bit CRCIP   @ IPR8.6;
bit DMAIP   @ IPR8.7;

bit CCP1IP  @ IPR7.0;
bit CCP2IP  @ IPR7.1;
bit CCP3IP  @ IPR7.2;
bit CCP4IP  @ IPR7.3;
bit CCP5IP  @ IPR7.4;

bit TMR1GIP @ IPR6.0;
bit TMR3GIP @ IPR6.1;
bit TMR5GIP @ IPR6.2;
bit TMR7GIP @ IPR6.3;

bit TMR1IP  @ IPR5.0;
bit TMR2IP  @ IPR5.1;
bit TMR3IP  @ IPR5.2;
bit TMR4IP  @ IPR5.3;
bit TMR5IP  @ IPR5.4;
bit TMR6IP  @ IPR5.5;
bit TMR7IP  @ IPR5.6;
bit TMR8IP  @ IPR5.7;

bit TX3IP   @ IPR4.0;
bit RC3IP   @ IPR4.1;
bit TX4IP   @ IPR4.2;
bit RC4IP   @ IPR4.3;
bit TX5IP   @ IPR4.4;
bit RC5IP   @ IPR4.5;

bit SSP1IP  @ IPR3.0;
bit BCL1IP  @ IPR3.1;
bit SSP2IP  @ IPR3.2;
bit BCL2IP  @ IPR3.3;
bit TX1IP   @ IPR3.4;
bit RC1IP   @ IPR3.5;
bit TX2IP   @ IPR3.6;
bit RC2IP   @ IPR3.7;

bit C1IP    @ IPR2.0;
bit C2IP    @ IPR2.1;
bit C3IP    @ IPR2.2;
bit ZCDIP   @ IPR2.6;
bit HLVDIP  @ IPR2.7;

bit ADIP    @ IPR1.0;
bit ADTIP   @ IPR1.1;
bit CSWIP   @ IPR1.6;
bit OSCFIP  @ IPR1.7;

bit INT0IP  @ IPR0.0;
bit INT1IP  @ IPR0.1;
bit INT2IP  @ IPR0.2;
bit INT3IP  @ IPR0.3;
bit IOCIP   @ IPR0.4;
bit TMR0IP  @ IPR0.5;

bit PPSLOCKED @ PPSLOCK.0;


#if __CC8E__ >= 1500
#pragma config /0 0xF8 FEXTOSC = LP // LP (crystal oscillator) optimized for 32.768 kHz; PFM set to low power
#pragma config /0 0xF9 FEXTOSC = XT // XT (crystal oscillator) above 100 kHz, below 8 MHz; PFM set to medium power
#pragma config /0 0xFA FEXTOSC = HS // HS (crystal oscillator) above 8 MHz; PFM set to high power
#pragma config /0 0xFC FEXTOSC = OFF // Oscillator not enabled
#pragma config /0 0xFD FEXTOSC = ECL // EC (external clock) below 100 kHz; PFM set to low power
#pragma config /0 0xFE FEXTOSC = ECM // EC (external clock) for 500 kHz to 8 MHz; PFM set to medium power
#pragma config /0 0xFF FEXTOSC = ECH // EC (external clock) above 8 MHz; PFM set to high power
#pragma config /0 0x8F RSTOSC = HFINTOSC_64MHZ // HFINTOSC with HFFRQ = 64 MHz and CDIV = 1:1
#pragma config /0 0xAF RSTOSC = EXTOSC_4PLL // EXTOSC with 4x PLL, with EXTOSC operating per FEXTOSC bits
#pragma config /0 0xCF RSTOSC = SOSC // Secondary Oscillator
#pragma config /0 0xDF RSTOSC = LFINTOSC // Low-Frequency Oscillator
#pragma config /0 0xEF RSTOSC = HFINTOSC_1MHZ // HFINTOSC with HFFRQ = 4 MHz and CDIV = 4:1
#pragma config /0 0xFF RSTOSC = EXTOSC // EXTOSC operating per FEXTOSC bits (device manufacturing default)
#pragma config /1 0xFE CLKOUTEN = ON // CLKOUT function is enabled
#pragma config /1 0xFF CLKOUTEN = OFF // CLKOUT function is disabled
#pragma config /1 0xF7 CSWEN = OFF // The NOSC and NDIV bits cannot be changed by user software
#pragma config /1 0xFF CSWEN = ON // Writing to NOSC and NDIV is allowed
#pragma config /1 0xDF FCMEN = OFF // Fail-Safe Clock Monitor disabled
#pragma config /1 0xFF FCMEN = ON // Fail-Safe Clock Monitor enabled
#pragma config /2 0xFE MCLRE = INTMCLR // If LVP = 0, MCLR pin function is port defined function; If LVP =1, RG5 pin fuction is MCLR
#pragma config /2 0xFF MCLRE = EXTMCLR // If LVP = 0, MCLR pin is MCLR; If LVP = 1, RG5 pin function is MCLR 
#pragma config /2 0xFD PWRTE = ON // Power up timer enabled
#pragma config /2 0xFF PWRTE = OFF // Power up timer disabled
#pragma config /2 0xDF LPBOREN = ON // ULPBOR enabled
#pragma config /2 0xFF LPBOREN = OFF // ULPBOR disabled
#pragma config /2 0x3F BOREN = OFF // Brown-out Reset disabled
#pragma config /2 0x7F BOREN = ON // Brown-out Reset enabled according to SBOREN
#pragma config /2 0xBF BOREN = NOSLP // Brown-out Reset enabled while running, disabled in Sleep; SBOREN is ignored
#pragma config /2 0xFF BOREN = SBORDIS // Brown-out Reset enabled , SBOREN bit is ignored
#pragma config /3 0xFC BORV = VBOR_285 // Brown-out Reset Voltage (VBOR) set to 2.85V
#pragma config /3 0xFD BORV = VBOR_270 // Brown-out Reset Voltage (VBOR) set to 2.70V
#pragma config /3 0xFE BORV = VBOR_245 // Brown-out Reset Voltage (VBOR) set to 2.45V
#ifdef _18F67k40
#pragma config /3 0xFF BORV = VBOR_2P45 // Brown-out Reset Voltage (VBOR) set to 2.45V
#endif
#ifdef _18LF67k40
#pragma config /3 0xFF BORV = VBOR_190 // Brown-out Reset Voltage (VBOR) set to 1.90V
#endif
#pragma config /3 0xFB ZCD = ON // ZCD always enabled
#pragma config /3 0xFF ZCD = OFF // ZCD disabled. ZCD can be enabled by setting the ZCDSEN bit of ZCDCON
#pragma config /3 0xF7 PPS1WAY = OFF // PPSLOCK bit can be set and cleared repeatedly (subject to the unlock sequence)
#pragma config /3 0xFF PPS1WAY = ON // PPSLOCK bit can be cleared and set only once; PPS registers remain locked after one clear/set cycle
#pragma config /3 0xEF STVREN = OFF // Stack full/underflow will not cause Reset
#pragma config /3 0xFF STVREN = ON // Stack full/underflow will cause Reset
#pragma config /3 0xDF DEBUG = ON // Background debugger enabled
#pragma config /3 0xFF DEBUG = OFF // Background debugger disabled
#pragma config /3 0x7F XINST = ON // Extended Instruction Set and Indexed Addressing Mode enabled
#pragma config /3 0xFF XINST = OFF // Extended Instruction Set and Indexed Addressing Mode disabled
#pragma config /4 0xE0 WDTCPS = WDTCPS_0 // Divider ratio 1:32
#pragma config /4 0xE1 WDTCPS = WDTCPS_1 // Divider ratio 1:64
#pragma config /4 0xE2 WDTCPS = WDTCPS_2 // Divider ratio 1:128
#pragma config /4 0xE3 WDTCPS = WDTCPS_3 // Divider ratio 1:256
#pragma config /4 0xE4 WDTCPS = WDTCPS_4 // Divider ratio 1:512
#pragma config /4 0xE5 WDTCPS = WDTCPS_5 // Divider ratio 1:1024
#pragma config /4 0xE6 WDTCPS = WDTCPS_6 // Divider ratio 1:2048
#pragma config /4 0xE7 WDTCPS = WDTCPS_7 // Divider ratio 1:4096
#pragma config /4 0xE8 WDTCPS = WDTCPS_8 // Divider ratio 1:8192
#pragma config /4 0xE9 WDTCPS = WDTCPS_9 // Divider ratio 1:16384
#pragma config /4 0xEA WDTCPS = WDTCPS_10 // Divider ratio 1:32768
#pragma config /4 0xEB WDTCPS = WDTCPS_11 // Divider ratio 1:65536
#pragma config /4 0xEC WDTCPS = WDTCPS_12 // Divider ratio 1:131072
#pragma config /4 0xED WDTCPS = WDTCPS_13 // Divider ratio 1:262144
#pragma config /4 0xEE WDTCPS = WDTCPS_14 // Divider ratio 1:524299
#pragma config /4 0xEF WDTCPS = WDTCPS_15 // Divider ratio 1:1048576
#pragma config /4 0xF0 WDTCPS = WDTCPS_16 // Divider ratio 1:2097152
#pragma config /4 0xF1 WDTCPS = WDTCPS_17 // Divider ratio 1:4194304
#pragma config /4 0xF2 WDTCPS = WDTCPS_18 // Divider ratio 1:8388608
#pragma config /4 0xF3 WDTCPS = WDTCPS_19 // Divider ratio 1:32
#pragma config /4 0xF4 WDTCPS = WDTCPS_20 // Divider ratio 1:32
#pragma config /4 0xF5 WDTCPS = WDTCPS_21 // Divider ratio 1:32
#pragma config /4 0xF6 WDTCPS = WDTCPS_22 // Divider ratio 1:32
#pragma config /4 0xF7 WDTCPS = WDTCPS_23 // Divider ratio 1:32
#pragma config /4 0xF8 WDTCPS = WDTCPS_24 // Divider ratio 1:32
#pragma config /4 0xF9 WDTCPS = WDTCPS_25 // Divider ratio 1:32
#pragma config /4 0xFA WDTCPS = WDTCPS_26 // Divider ratio 1:32
#pragma config /4 0xFB WDTCPS = WDTCPS_27 // Divider ratio 1:32
#pragma config /4 0xFC WDTCPS = WDTCPS_28 // Divider ratio 1:32
#pragma config /4 0xFD WDTCPS = WDTCPS_29 // Divider ratio 1:32
#pragma config /4 0xFE WDTCPS = WDTCPS_30 // Divider ratio 1:32
#pragma config /4 0xFF WDTCPS = WDTCPS_31 // Divider ratio 1:65536; software control of WDTPS
#pragma config /4 0x9F WDTE = OFF // WDT Disabled
#pragma config /4 0xBF WDTE = SWDTEN // WDT enabled/disabled by SWDTEN bit
#pragma config /4 0xDF WDTE = NSLEEP // WDT enabled while sleep=0, suspended when sleep=1
#pragma config /4 0xFF WDTE = ON // WDT enabled regardless of sleep
#pragma config /5 0xF8 WDTCWS = WDTCWS_0 // window delay = 87.5; no software control; keyed access required
#pragma config /5 0xF9 WDTCWS = WDTCWS_1 // window delay = 75 percent of time; no software control; keyed access required
#pragma config /5 0xFA WDTCWS = WDTCWS_2 // window delay = 62.5 percent of time; no software control; keyed access required
#pragma config /5 0xFB WDTCWS = WDTCWS_3 // window delay = 50 percent of time; no software control; keyed access required
#pragma config /5 0xFC WDTCWS = WDTCWS_4 // window delay = 37.5 percent of time; no software control; keyed access required
#pragma config /5 0xFD WDTCWS = WDTCWS_5 // window delay = 25 percent of time; no software control; keyed access required
#pragma config /5 0xFE WDTCWS = WDTCWS_6 // window always open (100%); no software control; keyed access required
#pragma config /5 0xFF WDTCWS = WDTCWS_7 // window always open (100%); software control; keyed access not required
#pragma config /5 0xC7 WDTCCS = LFINTOSC // WDT reference clock is the 31.0 kHz LFINTOSC
#pragma config /5 0xCF WDTCCS = HFINTOSC // WDT reference clock is the 31.2kHz HFINTOSC output
#pragma config /5 0xFF WDTCCS = SC // Software Control
#pragma config /6 0xFE WRT0 = ON // Block 0 (000800-003FFFh) write-protected
#pragma config /6 0xFF WRT0 = OFF // Block 0 (000800-003FFFh) not write-protected
#pragma config /6 0xFD WRT1 = ON // Block 1 (004000-007FFFh) write-protected
#pragma config /6 0xFF WRT1 = OFF // Block 1 (004000-007FFFh) not write-protected
#pragma config /6 0xFB WRT2 = ON // Block 2 (008000-00BFFFh) write-protected
#pragma config /6 0xFF WRT2 = OFF // Block 2 (008000-00BFFFh) not write-protected
#pragma config /6 0xF7 WRT3 = ON // Block 3 (00C000-00FFFFh) write-protected
#pragma config /6 0xFF WRT3 = OFF // Block 3 (00C000-00FFFFh) not write-protected
#pragma config /6 0xEF WRT4 = ON // Block 4 (010000-013FFFh) write-protected
#pragma config /6 0xFF WRT4 = OFF // Block 4 (010000-013FFFh) not write-protected
#pragma config /6 0xDF WRT5 = ON // Block 5 (014000-017FFFh) write-protected
#pragma config /6 0xFF WRT5 = OFF // Block 5 (014000-017FFFh) not write-protected
#pragma config /6 0xBF WRT6 = ON // Block 6 (018000-01BFFFh) write-protected
#pragma config /6 0xFF WRT6 = OFF // Block 6 (018000-01BFFFh) not write-protected
#pragma config /6 0x7F WRT7 = ON // Block 7 (01C000-01FFFFh) write-protected
#pragma config /6 0xFF WRT7 = OFF // Block 7 (01C000-01FFFFh) not write-protected
#pragma config /7 0xFE WRTC = ON // Configuration registers (300000-30000Bh) write-protected
#pragma config /7 0xFF WRTC = OFF // Configuration registers (300000-30000Bh) not write-protected
#pragma config /7 0xFD WRTB = ON // Boot Block (000000-0007FFh) write-protected
#pragma config /7 0xFF WRTB = OFF // Boot Block (000000-0007FFh) not write-protected
#pragma config /7 0xFB WRTD = ON // Data EEPROM write-protected
#pragma config /7 0xFF WRTD = OFF // Data EEPROM not write-protected
#pragma config /7 0xEF SCANE = OFF // Scanner module is NOT available for use, SCANMD bit is ignored
#pragma config /7 0xFF SCANE = ON // Scanner module is available for use, SCANMD bit can control the module
#pragma config /7 0xDF LVP = OFF // HV on MCLR/VPP must be used for programming
#pragma config /7 0xFF LVP = ON // Low voltage programming enabled. MCLR/VPP pin function is MCLR. MCLRE configuration bit is ignored
#pragma config /8 0xFE CP = ON // UserNVM code protection enabled
#pragma config /8 0xFF CP = OFF // UserNVM code protection disabled
#pragma config /8 0xFD CPD = ON // DataNVM code protection enabled
#pragma config /8 0xFF CPD = OFF // DataNVM code protection disabled
#pragma config /10 0xFE EBTR0 = ON // Block 0 (000800-003FFFh) protected from table reads executed in other blocks
#pragma config /10 0xFF EBTR0 = OFF // Block 0 (000800-003FFFh) not protected from table reads executed in other blocks
#pragma config /10 0xFD EBTR1 = ON // Block 1 (004000-007FFFh) protected from table reads executed in other blocks
#pragma config /10 0xFF EBTR1 = OFF // Block 1 (004000-007FFFh) not protected from table reads executed in other blocks
#pragma config /10 0xFB EBTR2 = ON // Block 2 (008000-00BFFFh) protected from table reads executed in other blocks
#pragma config /10 0xFF EBTR2 = OFF // Block 2 (008000-00BFFFh) not protected from table reads executed in other blocks
#pragma config /10 0xF7 EBTR3 = ON // Block 3 (00C000-00FFFFh) protected from table reads executed in other blocks
#pragma config /10 0xFF EBTR3 = OFF // Block 3 (00C000-00FFFFh) not protected from table reads executed in other blocks
#pragma config /10 0xEF EBTR4 = ON // Block 4 (010000-013FFFh) protected from table reads executed in other blocks
#pragma config /10 0xFF EBTR4 = OFF // Block 4 (010000-013FFFh) not protected from table reads executed in other blocks
#pragma config /10 0xDF EBTR5 = ON // Block 5 (014000-017FFFh) protected from table reads executed in other blocks
#pragma config /10 0xFF EBTR5 = OFF // Block 5 (014000-017FFFh) not protected from table reads executed in other blocks
#pragma config /10 0xBF EBTR6 = ON // Block 6 (018000-01BFFFh) protected from table reads executed in other blocks
#pragma config /10 0xFF EBTR6 = OFF // Block 6 (018000-01BFFFh) not protected from table reads executed in other blocks
#pragma config /10 0x7F EBTR7 = ON // Block 7 (01C000-01FFFFh) protected from table reads executed in other blocks
#pragma config /10 0xFF EBTR7 = OFF // Block 7 (01C000-01FFFFh) not protected from table reads executed in other blocks
#pragma config /11 0xFD EBTRB = ON // Boot Block (000000-0007FFh) protected from table reads executed in other blocks
#pragma config /11 0xFF EBTRB = OFF // Boot Block (000000-0007FFh) not protected from table reads executed in other blocks
#endif
